/*
 * Copyright (C) 2009 by Eric Lambert <Eric.Lambert@sun.com>
 * Use and distribution licensed under the
 * GNU Lesser General Public License (LGPL) version 2.1.
 * See the COPYING file in the parent directory for full text.
 */
package org.gearman.client;

import org.gearman.common.GearmanException;
import org.gearman.common.GearmanPacket;
import org.gearman.common.PacketType;
import org.gearman.common.GearmanServerResponseHandler;

public class GearmanEchoResponseHandler implements GearmanServerResponseHandler {

    private static final String DESCRIPTION = "GearmanEcho";
    byte[] data = null;
    boolean done = false;

    public void handleEvent(GearmanPacket response) throws GearmanException {
        PacketType pt = response.getPacketType();
        if (!pt.equals(PacketType.ECHO_RES)) {
            throw new GearmanException("Dont know how to hanlde response of" +
                    " type " + pt);
        }
        data = response.getData();
        done = true;
    }

    public boolean isDone() {
        return done;
    }

    public String toString() {
        return DESCRIPTION;
    }

    //TODO throw excpetion if called before done?
    byte[] getResults() {
        byte[] ret = new byte[0];
        if (done) {
            ret = new byte[data.length];
            System.arraycopy(data, 0, ret, 0, ret.length);
        }
        return ret;
    }
}
