/*
 * Copyright (C) 2009 by Robert Stewart
 * Copyright (C) 2009 by Eric Herman <eric@freesa.org>
 * Use and distribution licensed under the 
 * GNU Lesser General Public License (LGPL) version 2.1.
 * See the COPYING file in the parent directory for full text.
 */
package org.gearman.example;

import org.gearman.client.GearmanJobResult;
import org.gearman.client.GearmanJobResultImpl;
import org.gearman.client.Job;
import org.gearman.worker.JobFunction;
import org.gearman.client.Job.JobState;
import org.gearman.util.ByteUtils;
import org.gearman.worker.AbstractGearmanFunction;

public class ReverseFunction extends AbstractGearmanFunction {

    public GearmanJobResult executeFunction() throws Exception {

        StringBuffer sb = null;
        if (this.data instanceof byte[]) {
            sb = new StringBuffer(ByteUtils.fromUTF8Bytes((byte[]) this.data));
        } else {
            sb = new StringBuffer(data.toString());
        }
        GearmanJobResult gjr = new GearmanJobResultImpl(this.jobHandle,
                true, sb.reverse().toString().getBytes(),
                new byte[0], new byte[0], 0, 0);
        return gjr;
    }

    public String getName() {
        return "reverse";
    }
}
